function AIPlayer::debug(%this, %line, %level, %error) {
	%group = %this.getGroup();

	if (isObject(%group) && %group.class $= AIManager) {
		%group.debug(%this, %line, %level, %error);
	}
}

function AIPlayer::setMoveIntent(%this, %intent, %direct, %pathed) {
	if (%direct $= "") {
		%direct = 1;
	}

	if (%pathed $= "") {
		%pathed = 1;
	}

	%this.moveIntent = %intent;

	%this.moveIntentAllowDirect = %direct;
	%this.moveIntentAllowPathed = %pathed;
}

function AIPlayer::onMoveIntentFail(%this, %intent) {
}

function AIPlayer::updateAI(%this) {
	if (%this.getState() $= "Dead") {
		return;
	}

	%this.stop();
	%this.clearAim();

	%moveType = -1;

	if (%this.moveIntent !$= "") {
		if (%this.moveIntentAllowDirect && %this.directMovement()) {
			%moveType = 1;
		}
		else if (%this.moveIntentAllowPathed) {
			switch (%this.pathedMovement()) {
				case 2: %moveType = 0;
				case 1: %moveType = 2;
			}
		}

		if (%moveType == -1) {
			%moveType = 0;
			%original = %this.moveIntent;

			%this.moveIntent = "";
			%this.moveIntentAllowDirect = "";
			%this.moveIntentAllowPathed = "";

			%this.onMoveIntentFail(%original);
		}
	}
}

function AIPlayer::directMovement(%this) {
	return 0;
}

function AIPlayer::pathedMovement(%this) {
	return 0;
}

function AIPlayer::getNodeVisitCost(%this, %node) {
	return 0;
}
